// (C) 2017-2020 by folkert van heusden, released under AGPL v3.0
#pragma once

#include <atomic>
#include <string>
#include <thread>

#include "source.h"

class source_v4l : public source
{
protected:
	int fd, vw, vh;
	unsigned int pixelformat;
	const std::string pixel_format;
	bool rpi_workaround;

	struct buffer {
		void   *start;
		size_t length;
	};

	struct buffer *buffers = nullptr;
	int n_buffers;

public:
	source_v4l(const std::string & id, const std::string & descr, const std::string & exec_failure, const std::string & dev, const std::string & pixel_format, const bool rpi_workaround, const int jpeg_quality, const double max_fps, const int w_override, const int h_override, resize *const r, const int resize_w, const int resize_h, const int loglevel, const double timeout, std::vector<filter *> *const filters);
	virtual ~source_v4l();

	virtual void operator()() override;
};
